indexing
   title:       "LEX";
   cluster:     " ";
   project:     " ";
   copyright:   "SIG Computer", 1995;
   author:      "Alexei Simonov (alex@eiffel.ru)";
   original:    22,Sep,95;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   license:     "GNU Library GPL - see included readme file";
   extrnl_name: "lex.e";
-----------------------------------------------------------------------------
class LEX
-----------------------------------------------------------------------------
   inherit
      LEX_SERVER

--------------------------------------------------------------------- Queries
   feature -- Queries
------------------------------------------------------------------- constants
   INITIAL : INTEGER is 0;
   yy_end_of_buffer : INTEGER is 10;
------------------------------------------------------------------- atributes
   yy_hold_char      : CHARACTER;
   yy_n_chars        : INTEGER;
   -- number of characters read into yy_ch_buf
   yytext            : INTEGER;
   yyleng            : INTEGER;
   yy_c_buf_p        : INTEGER;
   -- points to current character in buffer
   yyout             : INTEGER;
   yyin              : INTEGER;
   in_index          : INTEGER;
   out_index         : INTEGER;
   yy_start          : INTEGER;
   f_yyout           : FILE [CHARACTER];
   f_yyin            : FILE [CHARACTER];
   io                : BASIC_IO;
   yy_init           : BOOLEAN;
   yy_current_buffer : YY_BUFFER_STATE;
   yy_buffer_flag    : BOOLEAN;
   yylex_loop_flag   : BOOLEAN;
   yy_did_buffer_switch_on_eof : INTEGER;
------------------------------------------------------------------------ make
   make is

   local
      yy_env : ENVIRONMENT;

   do
      !! yy_env;
      !! io;

      if yy_env.arg_count >= 1 and then not yy_env.arg_item (1).is_equal ("stdin") then
         if fs.file_exists (yy_env.arg_item (1)) then
            yyin := fs.access_file (yy_env.arg_item (1), "r", false);
         else
            lt.yy_fatal_error ("File not found");
         end -- if
      else
         yyin := 0;
      end -- if

      if yy_env.arg_count >= 2 then
         if not fs.file_exists (yy_env.arg_item (2)) then
            fs.add_file (yy_env.arg_item (2), "rw");
         end -- if
         yyout := fs.access_file (yy_env.arg_item (2), "rw", true);
      else
         yyout := 0;
      end -- if
      start_init;
      yylex;

   end -- make
--------------------------------------------------------- yy_do_before_action
   yy_do_before_action is

      do
         yytext := yy_bp;
			yyleng := yy_cp - yy_bp; 
         yy_hold_char := yy_current_buffer.yy_ch_buf.item (yy_cp);
         yy_current_buffer.set_yy_ch_buf ('%U', yy_cp);
         yy_c_buf_p := yy_cp;
      end -- yy_do_before_action
---------------------------------------------------------------------- yyless
--return all but the first 'n' matched characters back to the input stream
   yyless ( n : INTEGER ) is

      do
         -- undo effects of setting up yytext
         yy_current_buffer.set_yy_ch_buf (yy_hold_char, yy_cp);
         yy_c_buf_p := yy_bp + n;
         yy_cp := yy_bp + n;
         yy_do_before_action; -- set up yytext again
      end -- yyless
---------------------------------------------------------------------- yywrap
   yywrap : INTEGER is

   do
      Result := 1;
   end -- yywrap
   -- default yywrap function - always treat EOF as an EOF
----------------------------------------------------------------------- unput
   unput (c : CHARACTER) is

      do
         yyunput (c, yytext);
      end -- unput
----------------------------------------------------------------------- BEGIN
   BEGIN (i : INTEGER) is

      do
         yy_start := 1 + 2 * i;
      end -- BEGIN
------------------------------------------------------------------------ ECHO
   ECHO is

      do
         yy_print (yy_text);
      end -- ECHO
-----------------------------------------------------------------------------
yy_last_accepting_state : INTEGER;
yy_last_accepting_cpos  : INTEGER;

-- the intent behind this definition is that it'll catch
-- any uses of REJECT which flex missed
-- 
---------------------------------------------------------------------- REJECT
	REJECT is
		do
		-- reject_used_but_not_detected
		end -- REJECT
---------------------------------------------------------------------- yymore
	yymore () is
		do
		-- yymore_used_but_not_detected
		end -- yymore
yy_more_adj : INTEGER is 0
------------------------------------------------------------------ start_init
   start_init is

      do
         !! yy_current_state;
         yy_c_buf_p := 0;
         yy_init := true;
         -- whether we need to initialize
         yy_start := 0;
         -- start state number
         yy_buffer_flag := false;
         out_index := 1;
         in_index  := 1;
      end -- start_init
----------------------------------------------------------------- yy_new_file
   yy_new_file is
      -- special action meaning "start processing a new file"

      do

         yy_init_buffer (yy_current_buffer, yyin);
         yy_load_buffer_state;
      end -- yy_new_file
-------------------------------------------------------------- yy_init_buffer
   yy_init_buffer (b : YY_BUFFER_STATE; file : INTEGER) is

      do
         b.set_yy_input_file (file);
         b.set_yy_ch_buf ('%N', 0);
         b.set_yy_n_chars (1);

         b.set_yy_ch_buf (lt.yy_end_of_buffer_char, 1);
         b.set_yy_ch_buf (lt.yy_end_of_buffer_char, 2);

         b.set_yy_buf_pos (1);
         b.set_yy_eof_status (lt.eof_not_seen);
      end -- yy_init_buffer
-------------------------------------------------------- yy_load_buffer_state
   yy_load_buffer_state is

      do
         yy_n_chars   := yy_current_buffer.yy_n_chars;
         yytext       := yy_current_buffer.yy_buf_pos;
         yy_c_buf_p   := yy_current_buffer.yy_buf_pos;
         yyin         := yy_current_buffer.yy_input_file;
         yy_hold_char := yy_current_buffer.yy_ch_buf.item (yy_c_buf_p);
      end -- yy_load_buffer_state
------------------------------------------------------------------- yyrestart
   yyrestart (input_file : INTEGER) is

      do
         yy_init_buffer( yy_current_buffer, input_file );
         yy_load_buffer_state;
      end -- yyrestart
------------------------------------------------------------- yylex atributes
   yy_current_state : YY_STATE_TYPE;
   yy_cp            : INTEGER;
   yy_bp            : INTEGER;
   yy_act           : INTEGER;


 ----------------------------------------------------------- variable for yylex
  num_parse : INTEGER ;           -- Count in table tab_parse
  num_val : INTEGER ;             -- Count in table tab_val
  tab_parse : ARRAY[ INTEGER ] ;  -- Table for number lexem
  tab_val : ARRAY[ REAL ]         -- Table for meaning lexem
 ---------------------------------------------------------------- pop_tab_parse
 -- This procedure for put lexem in table
  pop_tab_parse( lex : INTEGER ) is
    do
      num_parse := num_parse + 1 ;
      tab_parse.resize( 1 , num_parse ) ;
      tab_parse.put( lex , num_parse ) ;
  end ; -- pop_tab_parse
 ------------------------------------------------------------------ pop_tab_val
 -- This procedure for put meaping lexem in table
  pop_tab_val(val : REAL) is
    do
      num_val := num_val + 1 ;
      tab_val.resize( 1 , num_val ) ;
      tab_val.put( val , num_val ) ;
  end ; -- pop_tab_val
 --------------------------------------------------------------- string_to_real
 -- This procedure for convert string to real
 string_to_real(str : STRING) : REAL is
  local format : FORMAT ;
  do
    !!format ;
    Result := format.s2r( str ) ;
 end ; -- string_to_real


----------------------------------------------------------------------- yylex
   yylex is

      do
         init;
         yylex_loop;
      end -- yylex
------------------------------------------------------------------------ init
   init is

      do
         if ( yy_init )  then

            if ( yy_start = 0)  then
               yy_start := 1;
               -- first start state
            end -- if

            if ( yyin /= 0 )  then
               !!f_yyin.connect_to (yyin);
            end -- if

            if ( yyout /= 0 )  then
               !!f_yyout.connect_to (yyout);
            end -- if

            if ( yy_buffer_flag ) then
                yy_init_buffer( yy_current_buffer, yyin );
            else
                !! yy_current_buffer.yy_create_buffer( lt.yy_buf_size, yyin ); --?
            end
            yy_load_buffer_state;
            yy_user_init;

            yy_init := false;
         end -- if
      end -- init
------------------------------------------------------------------ yylex_loop
   yylex_loop is

      do
         from
            yylex_loop_flag := true;
         until
            yylex_loop_flag = false
         loop
            -- loops until end-of-file is reached
            yy_cp := yy_c_buf_p;

            -- support of yytext
            yy_current_buffer.set_yy_ch_buf (yy_hold_char, yy_cp);

            -- yy_bp points to the position in yy_ch_buf of the start of the
            -- current run.
            --
            yy_bp := yy_cp;
				yy_current_state.set_int (yy_start);
            yy_match;
         end -- loop
      end -- yylex_loop
-------------------------------------------------------------------- yy_match
   yy_match is

      local
         yy_c : INTEGER
      do
			from
			until
				yy_current_state.int = 17
			loop
				yy_c := tb.yy_ec.item (yy_current_buffer.yy_ch_buf.item (yy_cp).to_integer);

				if ( tb.yy_accept.item (yy_current_state.int) > 0 ) then
					yy_last_accepting_state := yy_current_state.int;
					yy_last_accepting_cpos := yy_cp;
				end -- if
				from
				until
					tb.yy_chk.item (tb.yy_base.item (yy_current_state.int) + yy_c) = yy_current_state.int 
				loop
					yy_current_state.set_int (tb.yy_def.item (yy_current_state.int));
					if ( yy_current_state.int >= 18 ) then
						yy_c := tb.yy_meta.item (yy_c);
					end -- if
				end -- from
				yy_current_state.set_int (tb.yy_nxt.item (tb.yy_base.item (yy_current_state.int) + yy_c));
				yy_cp := yy_cp + 1;
			end -- from
			yy_cp := yy_last_accepting_cpos;
			yy_current_state.set_int (yy_last_accepting_state);
         yy_find_action;
      end -- yy_match
-------------------------------------------------------------- yy_find_action
   yy_find_action is

      do
			yy_act := tb.yy_accept.item (yy_current_state.int);
         yy_do_before_action;
         yy_user_action;
         do_action;
      end -- yy_find_action
------------------------------------------------------------------- do_action
   do_action is
   -- this procedure is used only to access EOF actions
      local
         yy_amount_of_matched_text : INTEGER;
         yy_next_state             : YY_STATE_TYPE;
      do
			if yy_act = 0 then -- must backtrack 
				-- undo the effects of YY_DO_BEFORE_ACTION 
				yy_current_buffer.set_yy_ch_buf (yy_hold_char, yy_cp);
				yy_cp := yy_last_accepting_cpos;

				yy_current_state.set_int (yy_last_accepting_state);

				yy_find_action ();

elseif yy_act = 1 then
pop_tab_parse( 258 ) ; pop_tab_val( string_to_real( yy_text ) ) ;
 -- Lexem Digits
elseif yy_act = 2 then
pop_tab_parse( 43 ) ;
 -- Lexem '+'
elseif yy_act = 3 then
pop_tab_parse( 45 ) ;
 -- Lexem '-'
elseif yy_act = 4 then
pop_tab_parse( 47 ) ;
 -- Lexem '/'
elseif yy_act = 5 then
pop_tab_parse( 42 ) ;
 -- Lexem '*'
elseif yy_act = 6 then
pop_tab_parse( 110 ) ;
 -- Lexem 'n'
elseif yy_act = 7 then
-- eat up whitespace
elseif yy_act = 8 then
yy_print ("Unrecognized character: ");
 ECHO;
 yy_print ("%N");
elseif yy_act = 9 then
	yylex_loop_flag := false;
elseif yy_act = ( yy_end_of_buffer + INITIAL + 1 ) then
	yylex_loop_flag := false;
         elseif yy_act = yy_end_of_buffer then
            -- amount of text matched not including the EOB char
            yy_amount_of_matched_text := yy_cp - yytext - 1;

            -- undo the effects of YY_DO_BEFORE_ACTION */
            yy_current_buffer.set_yy_ch_buf (yy_hold_char, yy_cp);

            -- note that here we test for yy_c_buf_p "<=" to the position
                  -- of the first EOB in the buffer, since yy_c_buf_p will
                  -- already have been incremented past the NUL character
                  -- (since all states make transitions on EOB to the end-
                  -- of-buffer state).  Contrast this with the test in yyinput().
                  --
            if ( yy_c_buf_p <= yy_n_chars ) then
                  -- this was really a NUL

                  yy_c_buf_p := yytext + yy_amount_of_matched_text;

                  yy_get_previous_state;

                  -- okay, we're now positioned to make the
                  -- NUL transition.  We couldn't have
                  -- yy_get_previous_state() go ahead and do it
                  -- for us because it doesn't know how to deal
                  -- with the possibility of jamming (and we
                  -- don't want to build jamming into it because
                  -- then it will run more slowly)
                  --

                  yy_try_NUL_trans;

                  yy_bp := yytext + yy_more_adj;

                  if (yy_current_state.state_flag) then
                     -- consume the NUL
                     yy_cp := yy_c_buf_p + 1;
                     -- yy_current_state := yy_next_state;
                     yy_match;
                  else
							yy_cp := yy_last_accepting_cpos;
							yy_current_state.set_int (yy_last_accepting_state);
                     yy_find_action;
                  end -- if
               else
                  inspect (yy_get_next_buffer)

                  when lt.eob_act_end_of_file then
                     yy_did_buffer_switch_on_eof := 0;

                     if (yywrap = 1) then
                        -- note: because we've taken care in
                        -- yy_get_next_buffer() to have set up yytext,
                        -- we can now set up yy_c_buf_p so that if some
                        -- total hoser (like flex itself) wants
                        -- to call the scanner after we return the
                        -- YY_NULL, it'll still work - another YY_NULL
                        -- will get returned.
                        --
                        yy_c_buf_p := yytext + yy_more_adj;

                        yy_act := (yy_end_of_buffer + (yy_start - 1) // 2 + 1);
                        do_action;
                     else

                        if (yy_did_buffer_switch_on_eof = 0) then
                           yy_new_file;
                        end -- if
                     end -- if
                  when lt.eob_act_continue_scan then
                     yy_c_buf_p := yytext + yy_amount_of_matched_text;

                     yy_get_previous_state;

                     yy_cp := yy_c_buf_p;
                     yy_bp := yytext + yy_more_adj;
                     yy_match;

                  when lt.eob_act_last_match then
                     yy_c_buf_p := yy_n_chars;

                     yy_get_previous_state;

                     yy_cp := yy_c_buf_p;
                     yy_bp := yytext + yy_more_adj;
                     yy_find_action;
                  end -- inspect
            end -- if
         else
            io.put_string ("action # ");
            io.put_int (yy_act);
            io.put_newline;
            lt.yy_fatal_error (
               "fatal flex scanner internal error--no action found");
         end -- if
      end -- do_action
------------------------------------------------------- yy_get_previous_state
--
-- yy_get_previous_state - get the state just before the EOB char was reached
--
-- synopsis
--     yy_get_previous_state;
--
-----------------------------------------------------------------------------
   yy_get_previous_state is

      local
         yy_c : INTEGER;

      do
			yy_current_state.set_int (yy_start);
      from
         yy_cp := yytext + yy_more_adj;
      until
         yy_cp = yy_c_buf_p
      loop
			if yy_current_buffer.yy_ch_buf.item (yy_cp) /= '%U' then
				yy_c := tb.yy_ec.item (yy_current_buffer.yy_ch_buf.item (yy_cp).to_integer);
			else
				yy_c := 1;
			end -- if
			if ( tb.yy_accept.item (yy_current_state.int) > 0 ) then
				yy_last_accepting_state := yy_current_state.int;
				yy_last_accepting_cpos := yy_cp;
			end -- if
			from
			until
				tb.yy_chk.item (tb.yy_base.item (yy_current_state.int) + yy_c) = yy_current_state.int 
			loop
				yy_current_state.set_int (tb.yy_def.item (yy_current_state.int));
				if ( yy_current_state.int >= 18 ) then
					yy_c := tb.yy_meta.item (yy_c);
				end -- if
			end -- from
			yy_current_state.set_int (tb.yy_nxt.item (tb.yy_base.item (yy_current_state.int) + yy_c));
         yy_cp := yy_cp + 1;
      end -- loop

      end -- yy_get_previous_state
------------------------------------------------------------ yy_try_NUL_trans
--
-- yy_try_NUL_trans - try to make a transition on the NUL character
--
-- synopsis
--     yy_try_NUL_trans;
--
-----------------------------------------------------------------------------

   yy_try_NUL_trans is

      local
         yy_is_jam : BOOLEAN;
         yy_c      : INTEGER;

      do
			yy_cp := yy_c_buf_p;

			yy_c := 1;

			if ( tb.yy_accept.item (yy_current_state.int) > 0 ) then
				yy_last_accepting_state := yy_current_state.int;
				yy_last_accepting_cpos := yy_cp;
			end -- if
			from
			until
				tb.yy_chk.item (tb.yy_base.item (yy_current_state.int) + yy_c) = yy_current_state.int 
			loop
				yy_current_state.set_int (tb.yy_def.item (yy_current_state.int));
				if ( yy_current_state.int >= 18 ) then
					yy_c := tb.yy_meta.item (yy_c);
				end -- if
			end -- from
			yy_current_state.set_int (tb.yy_nxt.item (tb.yy_base.item (yy_current_state.int) + yy_c));
			yy_is_jam := (yy_current_state.int = 17);
         if (yy_is_jam) then
            yy_current_state.set_state_flag (true);
         else
            yy_current_state.set_state_flag (false);
         end -- if
      end -- yy_try_NUL_trans
---------------------------------------------------------------- yy_user_init
   yy_user_init is

      do
      end -- yy_user_init
-------------------------------------------------------------- yy_user_action
   yy_user_action is
      do
      end -- yy_user_action
--------------------------------------------------------- yy_switch_to_buffer
   yy_switch_to_buffer (new_buffer : YY_BUFFER_STATE) is

      do
         if (not (yy_current_buffer = new_buffer)) then
            if ( yy_buffer_flag ) then
               -- flush out information for old buffer
               yy_current_buffer.set_yy_ch_buf (yy_hold_char, yy_c_buf_p);
               yy_current_buffer.set_yy_buf_pos (yy_c_buf_p);     --?
               yy_current_buffer.set_yy_n_chars (yy_n_chars);         --?
            end -- if
--            yy_current_buffer.copy (new_buffer);   -- ?
            yy_load_buffer_state;

            -- we don't actually know whether we did this switch during
            -- EOF (yywrap()) processing, but the only time this flag
            -- is looked at is after yywrap() is called, so it's safe
            -- to go ahead and always set it.

             yy_did_buffer_switch_on_eof := 1;
         end -- if
      end -- yy_switch_to_buffer
---------------------------------------------------------- yy_get_next_buffer
-- yy_get_next_buffer - try to read in a new buffer
--
-- synopsis
--     int yy_get_next_buffer;
--
-- returns a code representing an action
--     eob_act_last_match -
--     eob_act_continue_scan - continue scanning from current position
--     eob_act_end_of_file - end of file
-----------------------------------------------------------------------------
   yy_get_next_buffer : INTEGER is

      local
         dest, source, number_to_move, ret_val, num_to_read, i : INTEGER;

      do
         dest := 0;
         source := yytext - 1;

         if ( yy_c_buf_p > yy_n_chars + 1) then
            lt.yy_fatal_error (
            "fatal flex scanner internal error--end of buffer missed");
         end -- if

         -- try to read more data

         -- first move last chars to start of buffer
         number_to_move := yy_c_buf_p - yytext;
         from
            i := 0;
         until
            i = number_to_move;
         loop
            yy_current_buffer.set_yy_ch_buf (yy_current_buffer.yy_ch_buf.item (source + i), dest + i);
            i := i + 1;
         end -- loop

         if (yy_current_buffer.yy_eof_status /= lt.eof_not_seen) then
            -- don't do the read, it's not guaranteed to return an EOF,
            -- just force an EOF
            --
            yy_n_chars := 0;

         else
            num_to_read := yy_current_buffer.yy_buf_size - number_to_move - 1;

            if (num_to_read > lt.yy_read_buf_size ) then
               num_to_read := lt.yy_read_buf_size;
            elseif ( num_to_read <= 0 ) then
               lt.yy_fatal_error ("fatal error - scanner input buffer overflow");
            end -- if
            -- read in more data */
            yy_n_chars := yy_read (yyin, number_to_move, num_to_read);
         end -- if

         if (yy_n_chars = 0) then
            if (number_to_move = 1) then
               ret_val := lt.eob_act_end_of_file;
               yy_current_buffer.set_yy_eof_status (lt.eof_done);

            else
               ret_val := lt.eob_act_last_match;
               yy_current_buffer.set_yy_eof_status (lt.eof_pending);
            end -- if

         else
            ret_val := lt.eob_act_continue_scan;
         end -- if
         yy_n_chars := yy_n_chars + number_to_move;
         yy_current_buffer.set_yy_ch_buf (lt.yy_end_of_buffer_char, yy_n_chars);
         yy_current_buffer.set_yy_ch_buf (lt.yy_end_of_buffer_char, yy_n_chars + 1);

         -- yytext begins at the second character in yy_ch_buf; the first
         -- character is the one which preceded it before reading in the latest
         -- buffer; it needs to be kept around in case it's a newline, so
         -- yy_get_previous_state() will have with '^' rules active
         --

         yytext := 1;

         Result := ret_val;
      end -- yy_get_next_buffer
--------------------------------------------------------------------- yyunput
   yyunput (c : CHARACTER; position : INTEGER) is

      local
         dest, source, number_to_move  : INTEGER

      do
         yy_cp := yy_c_buf_p;
         yy_bp := position;

         -- undo effects of setting up yytext
         yy_current_buffer.set_yy_ch_buf (yy_hold_char, yy_cp);

         if ( yy_cp < 2 ) then
            -- need to shift things up to make room
            number_to_move := yy_n_chars + 2; -- +2 for EOB chars
            dest := yy_current_buffer.yy_buf_size + 2;
            source := number_to_move;
            from
            until
               source = 0
            loop
               dest := dest - 1;
               source := source - 1;
               yy_current_buffer.set_yy_ch_buf (yy_current_buffer.yy_ch_buf.item (source), dest);
            end -- loop

            yy_cp := yy_cp + dest - source;
            yy_bp := yy_bp + dest - source;
            yy_n_chars := yy_current_buffer.yy_buf_size;

            if ( yy_cp < 2 ) then
                lt.yy_fatal_error ("flex scanner push-back overflow");
            end -- if
         end -- if

         if ( yy_cp > yy_bp and yy_current_buffer.yy_ch_buf.item (yy_cp - 1) = '%N' ) then
            yy_current_buffer.set_yy_ch_buf ('%N', yy_cp - 2);
         end -- if
         yy_cp := yy_cp - 1;
         yy_current_buffer.set_yy_ch_buf (c, yy_cp);

         -- note: the formal parameter *must* be called "yy_bp" for this
         --       macro to now work correctly
         --
         yy_do_before_action; -- set up yytext again
      end -- yyunput
----------------------------------------------------------------------- input
   input : CHARACTER is

      local
         c      : CHARACTER;
         yy_c   : INTEGER;
         c_flag : BOOLEAN;

      do
         c_flag := true;
         yy_c := yy_c_buf_p;

         yy_current_buffer.set_yy_ch_buf (yy_hold_char, yy_c);

         if (yy_current_buffer.yy_ch_buf.item (yy_c_buf_p) = lt.yy_end_of_buffer_char) then
            -- yy_c_buf_p now points to the character we want to return.
            -- If this occurs *before* the EOB characters, then it's a
            -- valid NUL; if not, then we've hit the end of the buffer.
            --
            if (yy_c_buf_p < yy_n_chars) then
               -- this was really a NUL
               yy_current_buffer.set_yy_ch_buf ('%U', yy_c_buf_p);

            else
               -- need more input
               yytext := yy_c_buf_p;
               yy_c_buf_p := yy_c_buf_p + 1;

               inspect (yy_get_next_buffer)

               when lt.eob_act_end_of_file then
                  if (yywrap = 1) then
                     yy_c_buf_p := yytext + yy_more_adj;
                     c_flag := false;
                     Result := '%U';
                  else
                     yy_new_file;
                     c_flag := false;
                     Result := input;
                  end -- if

               when lt.eob_act_continue_scan then
                  yy_c_buf_p := yytext + yy_more_adj;

               when lt.eob_act_last_match then
                  c_flag := false;
                  lt.yy_fatal_error( "unexpected last match in input()" );
               end -- inspect
            end -- if
         end -- if
         if c_flag  then
            c := yy_current_buffer.yy_ch_buf.item (yy_c_buf_p);
            yy_c_buf_p := yy_c_buf_p + 1;
            yy_hold_char := yy_current_buffer.yy_ch_buf.item (yy_c_buf_p);
            Result := c;
         end -- if
      end -- input
---------------------------------------------------------------------- output
   output (c : CHARACTER) is

      do
         if yyout = 0 then
            io.put_char (c);
         else
            if c = '%N' then
               f_yyout.put ('%/13/', out_index);
               out_index := out_index + 1;
               f_yyout.put ('%/10/', out_index);
            else
               f_yyout.put (c, out_index);
            end -- if
            out_index := out_index + 1;
         end -- if
      end -- output
--------------------------------------------------------------------- yy_read
   yy_read (in : INTEGER; pos : INTEGER; n : INTEGER) : INTEGER is

      local
         i, j, k : INTEGER;

      do
         if in = 0 then
            io.get_string;
            from
               i := 0;
               j := io.last_string.count;
            until
               i = j
            loop
               yy_current_buffer.set_yy_ch_buf (io.last_string.item (i + 1), i + pos);
               i := i + 1;
            end -- loop
            yy_current_buffer.set_yy_ch_buf ('%N', i + pos);
            Result := i + 1;
         else
            from
               i := 0;
               j := n;
               k := f_yyin.count - in_index + 1;
            until
               i = j or i = k
            loop
               yy_current_buffer.set_yy_ch_buf (f_yyin.item (in_index + i), i + pos);
               i := i + 1;
            end -- loop
            in_index := in_index + i;
            Result := i;
         end -- if
      end -- yy_read
--------------------------------------------------------------------- yy_text
   yy_text : STRING is

      local
         text : STRING;
         i    : INTEGER;

      do
         !! text.make (yyleng);
         from
            i := 0;
         until
            i = yyleng
         loop
            text.put (yy_current_buffer.yy_ch_buf.item (yytext + i), i + 1);
            i := i + 1;
         end -- loop
         Result := text;
      end -- yy_text
----------------------------------------------------------------------- print
   print (text : STRING; file : FILE [CHARACTER]; position : INTEGER ) : INTEGER is

      local
         i, j : INTEGER;

      do
         from
            i := 0;
            j := text.count;
         until
            i >= j
         loop
            if text.item (i + 1) = '%N' then
               file.put ('%/13/', position + i);
               i := i + 1;
               file.put ('%/10/', position + i);
            else
               file.put (text.item (i + 1), position + i);
            end; -- if
            i := i + 1;
         end -- loop

         Result := i;
      end -- print
-------------------------------------------------------------------- yy_print
   yy_print (text : STRING) is

      do
         if yyout = 0 then
            io.put_string (text);
         else
            out_index := out_index + print (text, f_yyout, out_index);
         end -- if
      end -- yy_print
-----------------------------------------------------------------------------
end -- class LEX
-----------------------------------------------------------------------------
