/* -------------------------------------------------------------------------
   -- It sintaxis analisis for calculate.                                 --
   -- the signum operators  and  the error lexem.                         --
   -- Operators :                                                         --
   -- 1. Bynary : '+' , '-' , '*' , '/'  ;                                --
   -- 2. Unary  : '^' '-' ; ( the prefix record ).                        --
   -- Digits    :                                                         --
   -- 1. With the point -                                                 --
   -- Example : '9.9' , '9.' , '.9'.                                      --
    -- 2. Not the point -                                                 --
   -- Example : '9' , '90' .                                              --
   -- Paren : '(' , ')' .                                                 --
   -- Example record - "^ 9" , "4.0 + ( 5 - ( 10 + - 3 ) * ^ 2.8 ) / 4".  --
   --                                                                     --
   -- Dmitriy E. Devyatkin                                                --
   -------------------------------------------------------------------------*/

/* Infix notation calculator */

%yystype { REAL } /* Type meahing lexem */

%{ !!fl.make1;	%}  /* Create object for lexical analisis */

/* BISON Declarations */

%token NUM  777
%left '-' '+'
%left '*' '/'
%left NEG     /* negation--unary minus */
%right '^'    /* power */
/* Grammar follows */

%%
input:    /* empty string */
        | input line
;
line:	  '\n' /* New line */
	| exp '\n'  { yyio.put_real( $1 ); yyio.put_string("%N");} /* Input result */
	| error '\n' { if fl.tab_error.count > 0  then
   yyio.put_string("%NIncorrect lexem : ");
   yyio.put_string(fl.tab_error.item(1));
   yyio.put_string(".%N");
else
   yyio.put_string("%N Sequences lexems incorrect.%N");
end ; -- if }	/* Errors */
;
exp:	  NUM		     {$$ = $1}	 /* Digits */
	| exp '+' exp        {$$ = $1 + $3} /* Binary '+' */
	| exp '-' exp        {$$ = $1 - $3} /* Binary '-' */
	| exp '*' exp        {$$ = $1 * $3} /* Binary '*' */
	| exp '/' exp        {$$ = $1 / $3} /* Binary '/' */
	| '-' exp  %prec NEG {$$ = -$2} /* Unary '-' */
	| '^' exp            {$$ = pow2( $2 )} /* Unary ^ (power) */
	| '(' exp ')'        {$$ = $2} /* paren expresion   */
;
%%
-------------------------------------------------------- variable for parser
con_parse : INTEGER ;     -- Counter for tab_parse
con_val   : INTEGER ;     -- Counter for tab_val
fl        : FLEX ;        -- Variable type lexical analisis
---------------------------------------------------------------------- yylex
-- This procedure lexical analisis. It return number next lexem.
yylex : INTEGER is
  do
    con_parse := con_parse + 1 ;
    if con_parse <= fl.tab_parse.upper then
       if ( fl.tab_parse.item( con_parse ) = 777 ) then
	  con_val := con_val + 1 ;
	  yylval.set( fl.tab_val.item( con_val ) ) ;
          Result :=  777 ;
       else
	  Result := fl.tab_parse.item( con_parse ) ;
       end ; -- if
    end ; -- if
end ; -- yylex
----------------------------------------------------------------------- pow2
pow2( dig : REAL ) : REAL is
  do
    Result := dig * dig ;
end ; -- if
