%{
 ------------------------------------------------------------------------------
 -- Lexical analisis for calculate. It output lexems type 'digits' ,         --
 -- the signum operators  and  the error lexem. 			     --
 -- Operators : 							     --
 -- 1. Bynary : '+' , '-' , '*' , '/'  ;                                     --
 -- 2. Unary  : '^' '-' ; ( the prefix record ).                             --
 -- Digits    : 							     --
 -- 1. With the point - 						     --
 -- Example : '9.9' , '9.' , '.9'.                                           --
 -- 2. Not the point -							     --
 -- Example : '9' , '90' .                                                   --
 -- Paren : '(' , ')' .                                                      --
 -- Example record - "^ 9" , "4.0 + ( 5 - ( 10 + - 3 ) * ^ 2.8 ) / 4" .      --
 --									     --
 -- Dmitriy E. Devyatkin						     --
------------------------------------------------------------------------------
   creation
	make1
%}

DIGIT    [0-9]
WITESPASE       [ \t\n]

%%

 ----------------------------------------------------------- variable for yylex
  num_parse  : INTEGER ;	     -- Count in table tab_parse
  num_val    : INTEGER ;	     -- Count in table tab_val
  num_err    : INTEGER ;	     -- Count in table tab_error
  tab_parse  : ARRAY[ INTEGER ] ;    -- Table for number lexem
  tab_val    : ARRAY[ REAL ] ;	     -- Table for meaning lexem
  tab_error  : ARRAY[ STRING ] ;     -- Table for incorrect lexem
  flag_error : BOOLEAN ;	     -- Flag exist error
 ---------------------------------------------------------------- pop_tab_parse
 -- This procedure for put lexem in table
  pop_tab_parse( lex : INTEGER ) is
    do
      num_parse := num_parse + 1 ;
      tab_parse.resize( 1 , num_parse ) ;
      tab_parse.put( lex , num_parse ) ;
  end ; -- pop_tab_parse
 ------------------------------------------------------------------ pop_tab_val
 -- This procedure for put meaping lexem in table
  pop_tab_val(val : REAL) is
    do
      num_val := num_val + 1 ;
      tab_val.resize( 1 , num_val ) ;
      tab_val.put( val , num_val ) ;
  end ; -- pop_tab_val
 ---------------------------------------------------------------- pop_tab_error
 -- This procedure for put error ( string lexem ) in table
 pop_tab_error is
   do
      num_err := num_err + 1 ;
      tab_error.resize( 1 , num_err ) ;
      tab_error.put( "" , num_err ) ;
 end ; -- pop_tab_error
 --------------------------------------------------------------- string_to_real
 -- This procedure for convert string to real
 string_to_real(str : STRING) : REAL is
  local format : FORMAT ;
  do
    !!format ;
    Result := format.s2r( str ) ;
 end ; -- string_to_real


{DIGIT}+"."{DIGIT}*   pop_tab_parse( 777 ) ; pop_tab_val( string_to_real( yy_text ) ) ;
		      flag_error := false ;
 -- Lexem Digit with point

{DIGIT}+  pop_tab_parse( 777 ) ; pop_tab_val( string_to_real( yy_text ) ) ;
		      flag_error := false ;
 --  Lexem Digit with out point

"+"  pop_tab_parse( 43 ) ;
		      flag_error := false ;
 -- Lexem '+'

"-"  pop_tab_parse( 45 ) ;
		      flag_error := false ;
 -- Lexem '-'

"/"  pop_tab_parse( 47 ) ;
		      flag_error := false ;
 -- Lexem '/'

"*"  pop_tab_parse( 42 ) ;
		      flag_error := false ;
 -- Lexem '*'

"("  pop_tab_parse( 40 ) ;
		      flag_error := false ;
 -- Lexem '('

")"  pop_tab_parse( 41 ) ;
		      flag_error := false ;
 -- Lexem ')'

"^"  pop_tab_parse( 94 ) ;
		      flag_error := false ;
 -- Lexem '^'

{WITESPASE}+          -- eat up whitespace

.     if flag_error = false then
	 pop_tab_error( ) ;
	 tab_error.item( num_err ).append( yy_text ) ;
	 flag_error := true
      else
	 tab_error.item( num_err ).append( yy_text ) ;
	 flag_error := true
      end ; -- if
%%
make1 is
  do
    !!tab_parse.make( 1 , 0 ) ;
    !!tab_val.make( 1 , 0 ) ;
    !!tab_error.make( 1 , 0 ) ;
    flag_error := false ;
    make;
    num_parse := num_parse + 1 ;
    tab_parse.resize( 1 , num_parse ) ;
    tab_parse.put( 10 , num_parse ) ;
end ; -- make1
