indexing
   title:       " ";
   cluster:     " ";
   project:     " ";
   copyright:   "SIG Computer", 1995;
   author:      "Alexei Simonov (alex@eiffel.ru)";
   original:    22,Sep,95;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   license:     "GNU Library GPL - see included readme file";
   extrnl_name: "yy_buf_s.e";
-----------------------------------------------------------------------------
class YY_BUFFER_STATE
-----------------------------------------------------------------------------
   inherit
      LEX_SERVER

   creation
      yy_create_buffer
--------------------------------------------------------------------- Queries
   feature -- Queries
------------------------------------------------------------------- atributes
   yy_input_file : INTEGER;
   yy_ch_buf     : ARRAY [CHARACTER];
   yy_buf_pos    : INTEGER;

   yy_buf_size   : INTEGER;
   -- size of input buffer in bytes, not including room for EOB characters
   yy_n_chars    : INTEGER;
   -- number of characters read into yy_ch_buf, not including EOB characters
   yy_eof_status : INTEGER;
   -- whether we've seen an EOF on this buffer
------------------------------------------------------------ yy_create_buffer
   yy_create_buffer (size : INTEGER; file : INTEGER) is

      do
         yy_input_file := file;
         yy_buf_size   := size;
         yy_buf_pos    := 1;
         yy_n_chars    := 1;
         yy_eof_status := lt.eof_not_seen;

         !! yy_ch_buf.make (0, size + 2);
         yy_ch_buf.put ('%N', 0);
         yy_ch_buf.put (lt.yy_end_of_buffer_char, 1);
         yy_ch_buf.put (lt.yy_end_of_buffer_char, 2);
       end -- yy_create_buffer
------------------------------------------------------------------- infix "="
   infix "|=|" ( ts : like CURRENT ) :  BOOLEAN is

      do
         Result := Current.yy_input_file = ts.yy_input_file and then
            Current.yy_buf_pos = ts.yy_buf_pos and then
            Current.yy_buf_size = ts.yy_buf_size and then
            Current.yy_n_chars = ts.yy_n_chars and then
            Current.yy_eof_status = ts.yy_eof_status and then
            Current.yy_ch_buf.is_equal (ts.yy_ch_buf)
      end -- infix "="
----------------------------------------------------------- set_yy_input_file
   set_yy_input_file (input_file  : INTEGER) is

      do
         yy_input_file := input_file
      end -- set_yy_input_file
--------------------------------------------------------------- set_yy_ch_buf
   set_yy_ch_buf (ch_buf : CHARACTER; index : INTEGER) is

      do
         yy_ch_buf.put (ch_buf, index)
      end -- set_yy_ch_buf
-------------------------------------------------------------- set_yy_buf_pos
   set_yy_buf_pos (buf_pos : INTEGER) is

      do
         yy_buf_pos := buf_pos
      end -- set_yy_buf_pos
------------------------------------------------------------- set_yy_buf_size
   set_yy_buf_size (buf_size : INTEGER) is

      do
         yy_buf_size := buf_size
      end -- set_yy_buf_size
-------------------------------------------------------------- set_yy_n_chars
   set_yy_n_chars (n_chars : INTEGER) is

      do
         yy_n_chars := n_chars
      end -- set_yy_n_chars
----------------------------------------------------------- set_yy_eof_status
   set_yy_eof_status (eof_status : INTEGER) is

      do
         yy_eof_status := eof_status
      end -- set_yy_eof_status
-----------------------------------------------------------------------------
end -- class YY_BUFFER_STATE
-----------------------------------------------------------------------------
