##############################################################################
#indexing                                                                    #
#   title:       " ";                                                        #
#   cluster:     " ";                                                        #
#   project:     " ";                                                        #
#   copyright:   "SIG Computer", 1995;                                       #
#   author:      "Alexei Simonov (alex@eiffel.ru)";                          #
#   original:    22,Sep,95;                                                  #
#   version:     1.0;                                                        #
#   done_at:     "SIG Computer (info@eiffel.ru)";                            #
#   license:     "GNU Library GPL - see included readme file";               #
#   extrnl_name: "calcul.l";                                                 #
##############################################################################

%{
      rename
         make as make1
      redefine
         yy_user_init
      end
%}

DIGIT   [0-9]
WHITESPACE       [ \t]

%x expect expect1 expect2 expect3

%%

      digit_index : INTEGER;
      oper_prior  : INTEGER;
      prior_op    : INTEGER;
      form        : FORMAT;
      mat         : MATH;
      digit       : ARRAY [REAL];
      oper        : ARRAY [INTEGER];
      prior       : ARRAY [INTEGER];
 ------------------------------------------------------------------ calculate
 calculate : REAL is

    local
       i, j, range, max, max_index : INTEGER;
    do
       if prior_op /= 0 then
          yy_print ("Error in expression");
       end -- if
       from
          i := 1;
          range := oper_prior - 1;
       until
          i = oper_prior
       loop
          max := prior.item (1);
          max_index := 1;
          from
             j := 1
          until
             j > range
          loop
             if prior.item (j) > max then
                max := prior.item (j);
                max_index := j;
             end -- if
             j := j + 1;
          end -- loop

          inspect oper.item (max_index)

          when 1 then
             digit.put (digit.item (max_index) + digit.item (max_index + 1),
             max_index);
          when 2 then
             digit.put (digit.item (max_index) - digit.item (max_index + 1),
             max_index);
          when 3 then
             digit.put (digit.item (max_index) * digit.item (max_index + 1),
             max_index);
          when 4 then
             digit.put (digit.item (max_index) / digit.item (max_index + 1),
             max_index);
          when 5 then
             digit.put ( mat.exp (mat.log (digit.item (max_index)) * digit.item (max_index + 1)),
             max_index);
          else
             yy_print ("Error program");
          end -- inspect
          if max_index < range then
             digit.move (max_index + 2, range + 1, -1);
             oper.move (max_index + 1, range, -1);
             prior.move (max_index + 1, range, -1);
          end -- if
          range := range - 1;
          i := i + 1;
       end -- loop
       Result := digit.item (1);
    end -- calculate

<INITIAL,expect1>{DIGIT}+     %{
digit.put (form.s2r (yy_text), digit_index);
digit_index := digit_index + 1;
ECHO;
BEGIN (expect2);
%}

<INITIAL,expect1>{DIGIT}+"."{DIGIT}*     %{
digit.put (form.s2r (yy_text), digit_index);
digit_index := digit_index + 1;
ECHO;
BEGIN (expect2);
%}

"-"     %{
digit.put (-1.0, digit_index);
oper.put (3, oper_prior);
prior.put (prior_op + 1, oper_prior);
digit_index := digit_index + 1;
oper_prior  := oper_prior + 1;
ECHO;
BEGIN (expect1);
%}

<INITIAL,expect1>"("    %{
prior_op := prior_op + 3;
ECHO;
BEGIN (INITIAL);
%}

<expect2>"+"    %{
oper.put (1, oper_prior);
prior.put (prior_op, oper_prior);
oper_prior  := oper_prior + 1;
ECHO;
BEGIN (expect1);
%}

<expect2>"-"    %{
oper.put (2, oper_prior);
prior.put (prior_op, oper_prior);
oper_prior  := oper_prior + 1;
ECHO;
BEGIN (expect1);
%}

<expect2>"*"    %{
oper.put (3, oper_prior);
prior.put (prior_op + 1, oper_prior);
oper_prior  := oper_prior + 1;
ECHO;
BEGIN (expect1);
%}

<expect2>"/"    %{
oper.put (4, oper_prior);
prior.put (prior_op + 1, oper_prior);
oper_prior  := oper_prior + 1;
ECHO;
BEGIN (expect1);
%}

<expect2>"^"    %{
oper.put (5, oper_prior);
prior.put (prior_op + 2, oper_prior);
oper_prior  := oper_prior + 1;
ECHO;
BEGIN (expect1);
%}

<expect2>"="     %{
ECHO;
yy_print (form.r2s ("10.6", calculate));
yy_print ("%N");
digit_index := 1;
prior_op := 0;
oper_prior := 1;
BEGIN (INITIAL);
%}

<expect2>")"     %{
prior_op := prior_op - 3;
ECHO;
%}

<INITIAL,expect1,expect2>exit     %{
if yyin = 0 then
BEGIN (expect3);
io.put_string ("Quit to DOS? (Y/N)");
io.put_newline;
end -- if
%}

<expect3>"\n"

<expect3>"Y"|"y"   yylex_loop_flag := false;

<expect3>"N"|"n"   BEGIN (INITIAL);
 io.put_newline;

<expect3>.+     io.put_string ("??!!!... Quit to DOS? (Y/N)");
 io.put_newline;

<INITIAL,expect1,expect2>{WHITESPACE}*

<INITIAL,expect1,expect2>.    %{
yy_print ("Error in expression!");
BEGIN (INITIAL);
%}

<INITIAL,expect1,expect2>\n       -- new line

%%
---------------------------------------------------------------- yy_user_init
yy_user_init is

   do
      !! digit.make (1, 100);
      !! oper.make  (1, 100);
      !! prior.make (1, 100);
      !! form;
      !! mat;
      digit_index := 1;
      prior_op := 0;
      oper_prior := 1;
      if yyin = 0 then
         io.put_string ("PROGRAM CALCULATOR.  To quit type 'exit'%N");
      end -- if;
   end -- yy_user_init
------------------------------------------------------------------------ make
make is
   do
      make1;
   end -- make
