##############################################################################
#indexing                                                                    #
#   title:       " ";                                                        #
#   cluster:     " ";                                                        #
#   project:     " ";                                                        #
#   copyright:   "SIG Computer", 1995;                                       #
#   author:      "Alexei Simonov (alex@eiffel.ru)";                          #
#   original:    22,Sep,95;                                                  #
#   version:     1.0;                                                        #
#   done_at:     "SIG Computer (info@eiffel.ru)";                            #
#   license:     "GNU Library GPL - see included readme file";               #
#   extrnl_name: "eiffel.l";                                                 #
##############################################################################

%{
   rename
      make as make1
   end
%}

DIGIT    [0-9]
ID       [a-zA-Z][a-zA-Z0-9_]*
WHITESPACE       [ \t\n]

%%

{DIGIT}+    yy_print ("An INTEGER: ");
 ECHO;
 yy_print ("%N");

{DIGIT}+"."{DIGIT}*    yy_print ("A REAL: ");
 ECHO;
 yy_print ("%N");

true|false     yy_print ("A BOOLEAN: ");
 ECHO;
 yy_print ("%N");

'[^\n]*'     yytext := yytext + 1;
 unput (' ');
 yy_print ("A CHARACTER: ");
 ECHO;
 yy_print ("%N");

"!"{ID}?"!"       yy_print ("A creation instruction: ");
 ECHO;
 yy_print ("%N");

BOOLEAN|CHARACTER|INTEGER|REAL|STRING|DOUBLE|NONE|POINTER|BIT    yy_print ("A basic types: ");
 ECHO;
 yy_print ("%N");

"alias"|"deferred"|"ensure"|"from"|"inherit"|"local"|"once"|"rename"|"separate"|"unique"|"all"|"check"|"do"|"expanded"|"frozen"|"inspect"|"loop"|"require"|"until"|"class"|"export"|"if"|"rescue"|"strip"|"variant"|"as"|"creation"|"else"|"external"|"implies"|"invariant"|"prefix"|"Result"|"then"|"when"|"Current"|"elseif"|"indexing"|"is"|"obsolete"|"retry"|"debug"|"end"|"feature"|"infix"|"like"|"old"|"redefine"|"select"|"undefine"    yy_print ("A reserved word: ");
 ECHO;
 yy_print ("%N");

{ID}    yy_print ("An identifier: ");
 ECHO;
 yy_print ("%N");

":="|"?="   yy_print ("An Assignment instruction: ");
 ECHO;
 yy_print ("%N");

"not"|"or"|"xor"|"and"|"implies"|"or"[ \t]*"else"|"and"[ \t]*"then"     yy_print ("A BOOLEAN operator: ");
 ECHO;
 yy_print ("%N");

"+"|"-"|"*"|"/"|"^"   yy_print ("An INTEGER & REAL operator: ");
 ECHO;
 yy_print ("%N");

"//"|"\\\\"     yy_print ("An INTEGER operator: ");
 ECHO;
 yy_print ("%N");

"<<"|">>"     yy_print ("An angle bracets: ");
 ECHO;
 yy_print ("%N");

":"     yy_print ("A colon: ");
 ECHO;
 yy_print("%N");

"->"     yy_print ("An arrow: ");
 ECHO;
 yy_print("%N");

"\."     yy_print ("A dot: ");
 ECHO;
 yy_print("%N");

";"|","    yy_print ("A separates: ");
 ECHO;
 yy_print("%N");

"("|")"    yy_print ("A parentheses: ");
 ECHO;
 yy_print ("%N");

"{"|"}"    yy_print ("A braces: ");
 ECHO;
 yy_print ("%N");

"["|"]"    yy_print ("A brackets: ");
 ECHO;
 yy_print ("%N");

"\""[^\n]*"\""    yytext := yytext + 1;
 unput(' ');
 yy_print ("A STRING: ");
 ECHO;
 yy_print ("%N");

"--"[^\n]*    yy_print ("A line comments :%N");
 ECHO;
 yy_print ("%N");

"\.\."     yy_print ("A double dot: ");
 ECHO;
 yy_print ("%N");

"$"     yy_print ("An address operator: ");
 ECHO;
 yy_print ("%N");

"'"|"\""     yy_print ("A quote: ");
 ECHO;
 yy_print ("%N");

"&"|"#"|"\|"|"@"     yy_print ("A free operator: ");
 ECHO;
 yy_print ("%N");

"%"     yy_print ("A percent sign: ");
 ECHO;
 yy_print ("%N");

"="|"/="|"<"|">"|"<="|">="      yy_print ("A logical operators: ");
 ECHO;
 yy_print ("%N");

"{"[^}\n]*"}"     -- eat up one-line comments

{WHITESPACE}+          -- eat up whitespace

.    yy_print ("Unrecognized character: ");
 ECHO;
 yy_print ("%N");

%%
----------------------------------------------------------------------- make
make is
   do
      make1;
   end -- make

